local IsSearching = 0
local SearchQuery = nil
local HighestID = 150000
local CurrentID = 150000

SLASH_GetLink1 = "/gl"
SLASH_BuildLink1 = "/getlink"

SlashCmdList["GetLink"] = function(msg)
	GetLink_Command(msg)
end

SlashCmdList["BuildLink"] = function(msg)
	GetLinkBuild_Command(msg)
end

function GetLinkBuild_Command(msg)
	if tonumber(msg) then
		name, link = GetItemInfo(tonumber(msg))
		if link then
			DEFAULT_CHAT_FRAME:AddMessage(link)
			GLTable[tonumber(msg)] = link
		end
	elseif string.len(string.gsub(msg, "%p", "")) > 2 and IsSearching == 0 then
		SearchQuery = string.lower(string.gsub(msg, "%p", ""))
		IsSearching = 1
		CurrentID = HighestID
		DEFAULT_CHAT_FRAME:AddMessage("Not found; Appending table.")
	elseif string.len(msg) == 0 and IsSearching == 0 then
		SearchQuery = nil
		IsSearching = 1
		CurrentID = HighestID
		DEFAULT_CHAT_FRAME:AddMessage("Appending table.")
	elseif IsSearching == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Appending table, currently on ItemID "..CurrentID..".")
	end
end

function GetLink_Command(msg)
	if GLTable[tonumber(msg)] then
		DEFAULT_CHAT_FRAME:AddMessage(GLTable[tonumber(msg)])
	elseif string.len(string.gsub(msg, "%p", "")) > 2 then
		msg = string.lower(string.gsub(msg, "%p", ""))
		for idnum in pairs(GLTable) do
			if string.find(string.lower(GLTable[idnum]), msg) then
				DEFAULT_CHAT_FRAME:AddMessage(GLTable[idnum])
			end
		end
		DEFAULT_CHAT_FRAME:AddMessage("End of results.")
	end
end

function GetSearch(self, elapsed)
	if IsSearching == 1 and CurrentID > 5 then
		TickStop = CurrentID - 5
		while CurrentID > TickStop do
			if not GLTable[tonumber(CurrentID)] then
				name, link = GetItemInfo(CurrentID)
				if name then
					GLTable[tonumber(CurrentID)] = link
					if SearchQuery and string.find(string.lower(name), SearchQuery) then
						name, link = GetItemInfo(CurrentID)
						DEFAULT_CHAT_FRAME:AddMessage(link)
					end
				end
			elseif GLTable[tonumber(CurrentID)] then
				TickStop = TickStop - 1
				if SearchQuery and string.find(string.lower(GLTable[tonumber(CurrentID)]), SearchQuery) then
					DEFAULT_CHAT_FRAME:AddMessage(GLTable[tonumber(CurrentID)])
				end
			end
			CurrentID = CurrentID - 1
		end
	elseif IsSearching == 1 then
		IsSearching = 0
		DEFAULT_CHAT_FRAME:AddMessage("Done.")
	end
end

function EventHandler(self, event, arg1)
	if event == "ADDON_LOADED" then
		if GLTable == nil then
			GLTable = {}
		end
	elseif event == "GET_ITEM_INFO_RECEIVED" then
		if not GLTable[tonumber(arg1)] then
			name, link = GetItemInfo(arg1)
			GLTable[tonumber(arg1)] = link
		end
	end			
end

local SearchFrame = CreateFrame("Frame")
SearchFrame:RegisterEvent("ADDON_LOADED")
SearchFrame:RegisterEvent("GET_ITEM_INFO_RECEIVED")
SearchFrame:SetScript("OnUpdate", GetSearch)
SearchFrame:SetScript("OnEvent", EventHandler)

